diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy.h ns-3.46/src/wifi/model/wifi-phy.h
--- ns-3.45/src/wifi/model/wifi-phy.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy.h	2025-10-01 18:46:32.000000000 -0700
@@ -10,12 +10,22 @@
 #ifndef WIFI_PHY_H
 #define WIFI_PHY_H
 
-#include "phy-entity.h"
+#include "frame-capture-model.h"
+#include "interference-helper.h"
+#include "preamble-detection-model.h"
+#include "wifi-net-device.h"
 #include "wifi-phy-operating-channel.h"
 #include "wifi-phy-state-helper.h"
+#include "wifi-radio-energy-model.h"
 #include "wifi-standards.h"
 
+#include "ns3/attribute-container.h"
+#include "ns3/enum.h"
 #include "ns3/error-model.h"
+#include "ns3/mobility-model.h"
+#include "ns3/tuple.h"
+#include "ns3/uinteger.h"
+#include "ns3/wifi-export.h"
 
 #include <limits>
 
@@ -35,6 +45,7 @@
 {
 
 class Channel;
+class PhyEntity;
 class WifiNetDevice;
 class MobilityModel;
 class WifiPhyStateHelper;
@@ -51,7 +62,7 @@
  * @ingroup wifi
  *
  */
-class WifiPhy : public Object
+class WIFI_EXPORT WifiPhy : public Object
 {
   public:
     friend class PhyEntity;
@@ -934,14 +945,45 @@
      */
     Ptr<MobilityModel> GetMobility() const;
 
-    using ChannelTuple = std::tuple<uint8_t /* channel number */,
-                                    MHz_u /* channel width */,
-                                    WifiPhyBand /* WifiPhyBand */,
-                                    uint8_t /* primary20 index*/>; //!< Tuple identifying a segment
-                                                                   //!< of an operating channel
+    /// kept for backward compatibility, can be deprecated when using strong types
+    using ChannelTuple = WifiChannelConfig::SegmentWithoutUnits;
 
-    using ChannelSegments =
-        std::vector<ChannelTuple>; //!< segments identifying an operating channel
+    /// segments identifying an operating channel
+    using ChannelSegments = std::list<WifiChannelConfig::TupleWithoutUnits>;
+
+    /// AttributeValue type of a ChannelTuple object
+    using ChannelTupleValue =
+        TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>;
+
+    /// AttributeValue type of a ChannelSegments object
+    using ChannelSettingsValue = AttributeContainerValue<ChannelTupleValue, ';'>;
+
+    /**
+     * Get a checker for the ChannelSettings attribute, which can be used to deserialize a
+     * ChannelSegments object from a string:
+     *
+     * @code
+     *   WifiPhy::ChannelSettingsValue value;
+     *   value.DeserializeFromString("{36,0,BAND_5GHZ,0}", WifiPhy::GetChannelSegmentsChecker());
+     *   ChannelSettings channel = value.Get();
+     * @endcode
+     *
+     * Note that the WifiChannelConfig::FromString() static function uses the code above to return
+     * a WifiChannelConfig object starting from a string.
+     *
+     * @return a checker for the ChannelSettings attribute
+     */
+    static Ptr<const AttributeChecker> GetChannelSegmentsChecker();
+
+    /**
+     * The ChannelSettings attribute allows users to leave some parameters (e.g., the channel width)
+     * unspecified. This function is used to set such unspecified parameters to their default values
+     * in the given channel config.
+     *
+     * @param channelCfg the given channel settings
+     * @param standard the supported standard
+     */
+    static void SetUnspecifiedChannelParams(WifiChannelConfig& channelCfg, WifiStandard standard);
 
     /**
      * If the standard for this object has not been set yet, store the channel settings
@@ -967,12 +1009,12 @@
     void SetOperatingChannel(const ChannelSegments& channelSegments);
 
     /**
-     * This overloaded function is used when the operating channel
-     * consists of a single segment, identified by a tuple.
+     * This overloaded function is used to pass a WifiChannelConfig object from which
+     * the operating channel can be deduced.
      *
-     * @param tuple the segment identifying the operating channel
+     * @param channelCfg the channel config object
      */
-    void SetOperatingChannel(const ChannelTuple& tuple);
+    void SetOperatingChannel(const WifiChannelConfig& channelCfg);
 
     /**
      * Configure whether it is prohibited to change PHY band after initialization.
@@ -1162,7 +1204,8 @@
      * @param modulation the modulation class
      * @param phyEntity the PHY entity
      */
-    static void AddStaticPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity);
+    static void AddStaticPhyEntity(WifiModulationClass modulation,
+                                   std::shared_ptr<PhyEntity> phyEntity);
 
     /**
      * Get the __implemented__ PHY entity corresponding to the modulation class.
@@ -1172,7 +1215,8 @@
      * @param modulation the modulation class
      * @return the pointer to the static implemented PHY entity
      */
-    static const Ptr<const PhyEntity> GetStaticPhyEntity(WifiModulationClass modulation);
+    static const std::shared_ptr<const PhyEntity> GetStaticPhyEntity(
+        WifiModulationClass modulation);
 
     /**
      * Get the supported PHY entity to use for a received PPDU.
@@ -1185,7 +1229,7 @@
      * @param ppdu the received PPDU
      * @return the pointer to the supported PHY entity
      */
-    Ptr<PhyEntity> GetPhyEntityForPpdu(const Ptr<const WifiPpdu> ppdu) const;
+    std::shared_ptr<PhyEntity> GetPhyEntityForPpdu(const Ptr<const WifiPpdu> ppdu) const;
 
     /**
      * Get the supported PHY entity corresponding to the modulation class.
@@ -1193,20 +1237,20 @@
      * @param modulation the modulation class
      * @return the pointer to the supported PHY entity
      */
-    Ptr<PhyEntity> GetPhyEntity(WifiModulationClass modulation) const;
+    std::shared_ptr<PhyEntity> GetPhyEntity(WifiModulationClass modulation) const;
     /**
      * Get the supported PHY entity corresponding to the wifi standard.
      *
      * @param standard the wifi standard
      * @return the pointer to the supported PHY entity
      */
-    Ptr<PhyEntity> GetPhyEntity(WifiStandard standard) const;
+    std::shared_ptr<PhyEntity> GetPhyEntity(WifiStandard standard) const;
     /**
      * Get the latest PHY entity supported by this PHY instance.
      *
      * @return the latest PHY entity supported by this PHY instance
      */
-    Ptr<PhyEntity> GetLatestPhyEntity() const;
+    std::shared_ptr<PhyEntity> GetLatestPhyEntity() const;
 
     /**
      * @return the UID of the previously received PPDU (reset to UINT64_MAX upon transmission)
@@ -1335,7 +1379,7 @@
      * @param modulation the modulation class
      * @param phyEntity the PHY entity
      */
-    void AddPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity);
+    void AddPhyEntity(WifiModulationClass modulation, std::shared_ptr<PhyEntity> phyEntity);
 
     uint8_t m_phyId; //!< the index of the PHY in the vector of PHYs held by the WifiNetDevice
 
@@ -1378,7 +1422,7 @@
      * looking for WifiMode objects for which
      * WifiMode::IsMandatory() is true.
      */
-    std::map<WifiModulationClass, Ptr<PhyEntity>> m_phyEntities;
+    std::map<WifiModulationClass, std::shared_ptr<PhyEntity>> m_phyEntities;
 
     TracedCallback<Ptr<const WifiPpdu>, const WifiTxVector&>
         m_signalTransmissionCb; //!< Signal Transmission callback
@@ -1599,12 +1643,12 @@
      * For PHY entities supported by a given WifiPhy instance,
      * @see m_phyEntities.
      */
-    static std::map<WifiModulationClass, Ptr<PhyEntity>>& GetStaticPhyEntities();
+    static std::map<WifiModulationClass, std::shared_ptr<PhyEntity>>& GetStaticPhyEntities();
 
     WifiStandard m_standard;                    //!< WifiStandard
     WifiModulationClass m_maxModClassSupported; //!< max modulation class supported
     WifiPhyBand m_band;                         //!< WifiPhyBand
-    ChannelSegments m_channelSettings; //!< Store operating channel settings until initialization
+    WifiChannelConfig m_channelCfg; //!< Store operating channel config until initialization
     WifiPhyOperatingChannel m_operatingChannel; //!< Operating channel
     bool m_fixedPhyBand; //!< True to prohibit changing PHY band after initialization
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy-operating-channel.cc ns-3.46/src/wifi/model/wifi-phy-operating-channel.cc
--- ns-3.45/src/wifi/model/wifi-phy-operating-channel.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy-operating-channel.cc	2025-10-01 18:46:32.000000000 -0700
@@ -276,6 +276,12 @@
     return os;
 }
 
+const std::set<FrequencyChannelInfo>&
+WifiPhyOperatingChannel::GetFrequencyChannels()
+{
+    return m_frequencyChannels;
+}
+
 bool
 WifiPhyOperatingChannel::Compare::operator()(const ConstIterator& first,
                                              const ConstIterator& second) const
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy-operating-channel.h ns-3.46/src/wifi/model/wifi-phy-operating-channel.h
--- ns-3.45/src/wifi/model/wifi-phy-operating-channel.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy-operating-channel.h	2025-10-01 18:46:32.000000000 -0700
@@ -14,6 +14,8 @@
 #include "wifi-phy-common.h"
 #include "wifi-ru.h"
 
+#include "ns3/wifi-export.h"
+
 #include <optional>
 #include <set>
 #include <tuple>
@@ -25,7 +27,7 @@
 /**
  * A structure containing the information about a frequency channel
  */
-struct FrequencyChannelInfo
+struct WIFI_EXPORT FrequencyChannelInfo
 {
     /**
      * @brief spaceship operator.
@@ -57,7 +59,7 @@
  *
  * Class that keeps track of all information about the current PHY operating channel.
  */
-class WifiPhyOperatingChannel
+class WIFI_EXPORT WifiPhyOperatingChannel
 {
   public:
     /// Typedef for a const iterator pointing to a channel in the set of available channels
@@ -128,6 +130,13 @@
         m_frequencyChannels; //!< Available frequency channels
 
     /**
+     * Return a reference to the set of all available frequency channels
+     *
+     * @return reference to the set of frequency channels
+     */
+    static const std::set<FrequencyChannelInfo>& GetFrequencyChannels();
+
+    /**
      * Return true if a valid channel has been set, false otherwise.
      *
      * @return true if a valid channel has been set, false otherwise
@@ -359,7 +368,7 @@
                                    MHz_u width,
                                    WifiStandard standard,
                                    WifiPhyBand band,
-                                   ConstIterator start = m_frequencyChannels.begin());
+                                   ConstIterator start = GetFrequencyChannels().begin());
 
     /**
      * Get channel number of the primary channel
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy-state.h ns-3.46/src/wifi/model/wifi-phy-state.h
--- ns-3.45/src/wifi/model/wifi-phy-state.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy-state.h	2025-10-01 18:46:32.000000000 -0700
@@ -10,7 +10,6 @@
 #ifndef WIFI_PHY_STATE_H
 #define WIFI_PHY_STATE_H
 
-#include "ns3/deprecated.h"
 #include "ns3/fatal-error.h"
 
 namespace ns3
@@ -86,26 +85,4 @@
 
 } // namespace ns3
 
-/**
- * Deprecated WifiPhyState enums.
- *
- * Use WifiPhyState class enum symbols instead.
- * @{
- */
-NS_DEPRECATED_3_42("Use WifiPhyState::IDLE instead")
-static constexpr auto IDLE = ns3::WifiPhyState::IDLE;
-NS_DEPRECATED_3_42("Use WifiPhyState::CCA_BUSY instead")
-static constexpr auto CCA_BUSY = ns3::WifiPhyState::CCA_BUSY;
-NS_DEPRECATED_3_42("Use WifiPhyState::TX instead")
-static constexpr auto TX = ns3::WifiPhyState::TX;
-NS_DEPRECATED_3_42("Use WifiPhyState::RX instead")
-static constexpr auto RX = ns3::WifiPhyState::RX;
-NS_DEPRECATED_3_42("Use WifiPhyState::SWITCHING instead")
-static constexpr auto SWITCHING = ns3::WifiPhyState::SWITCHING;
-NS_DEPRECATED_3_42("Use WifiPhyState::SLEEP instead")
-static constexpr auto SLEEP = ns3::WifiPhyState::SLEEP;
-NS_DEPRECATED_3_42("Use WifiPhyState::OFF instead")
-static constexpr auto OFF = ns3::WifiPhyState::OFF;
-/**@}*/
-
 #endif /* WIFI_PHY_STATE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy-state-helper.cc ns-3.46/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.45/src/wifi/model/wifi-phy-state-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy-state-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -51,7 +51,7 @@
                 MakeTraceSourceAccessor(&WifiPhyStateHelper::m_rxOutcomeTrace),
                 "ns3::WifiPhyStateHelper::RxOutcomeTracedCallback")
             .AddTraceSource("RxError",
-                            "A packet has been received unsuccessfuly.",
+                            "A packet has been received unsuccessfully.",
                             MakeTraceSourceAccessor(&WifiPhyStateHelper::m_rxErrorTrace),
                             "ns3::WifiPhyStateHelper::RxEndErrorTracedCallback")
             .AddTraceSource("Tx",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-phy-state-helper.h ns-3.46/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.45/src/wifi/model/wifi-phy-state-helper.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-phy-state-helper.h	2025-10-01 18:46:32.000000000 -0700
@@ -9,7 +9,6 @@
 #ifndef WIFI_PHY_STATE_HELPER_H
 #define WIFI_PHY_STATE_HELPER_H
 
-#include "phy-entity.h"
 #include "wifi-phy-common.h"
 #include "wifi-phy-state.h"
 #include "wifi-ppdu.h"
@@ -18,6 +17,7 @@
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
+#include "ns3/wifi-export.h"
 
 #include <algorithm>
 #include <list>
@@ -51,9 +51,9 @@
                  const std::vector<bool>&>
     RxOkCallback;
 /**
- * Callback if PSDU unsuccessfuly received
+ * Callback if PSDU unsuccessfully received
  *
- * arg1: PSDU received unsuccessfuly
+ * arg1: PSDU received unsuccessfully
  */
 typedef Callback<void, Ptr<const WifiPsdu>> RxErrorCallback;
 
@@ -62,7 +62,7 @@
  *
  * This objects implements the PHY state machine of the Wifi device.
  */
-class WifiPhyStateHelper : public Object
+class WIFI_EXPORT WifiPhyStateHelper : public Object
 {
   public:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-remote-station-manager.cc ns-3.46/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.45/src/wifi/model/wifi-remote-station-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-remote-station-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1168,9 +1168,9 @@
     const auto& hdr = psdu->GetHeader(0);
 
     if (hdr.IsMgt() || (hdr.IsData() && !hdr.IsQosData()) ||
-        (hdr.IsQosData() && (!m_wifiMac->GetBaAgreementEstablishedAsOriginator(
-                                hdr.GetAddr1(),
-                                hdr.GetQosTid() || m_incrRetryCountUnderBa))))
+        (hdr.IsQosData() &&
+         (!m_wifiMac->GetBaAgreementEstablishedAsOriginator(hdr.GetAddr1(), hdr.GetQosTid()) ||
+          m_incrRetryCountUnderBa)))
     {
         psdu->IncrementRetryCount();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-remote-station-manager.h ns-3.46/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.45/src/wifi/model/wifi-remote-station-manager.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-remote-station-manager.h	2025-10-01 18:46:32.000000000 -0700
@@ -1055,7 +1055,7 @@
      * @param address the address of the receiver
      * @param nSuccessfulMpdus number of successfully transmitted MPDUs
      * A value of 0 means that the Block ACK was missed.
-     * @param nFailedMpdus number of unsuccessfuly transmitted MPDUs
+     * @param nFailedMpdus number of unsuccessfully transmitted MPDUs
      * @param rxSnr received SNR of the block ack frame itself
      * @param dataSnr data SNR reported by remote station
      * @param dataTxVector the TXVECTOR of the MPDUs we sent
@@ -1540,7 +1540,7 @@
      * @param station the station that sent the DATA to us
      * @param nSuccessfulMpdus number of successfully transmitted MPDUs.
      *        A value of 0 means that the Block ACK was missed.
-     * @param nFailedMpdus number of unsuccessfuly transmitted MPDUs.
+     * @param nFailedMpdus number of unsuccessfully transmitted MPDUs.
      * @param rxSnr received SNR of the block ack frame itself
      * @param dataSnr data SNR reported by remote station
      * @param dataChannelWidth the channel width of the A-MPDU we sent
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-standard-constants.cc ns-3.46/src/wifi/model/wifi-standard-constants.cc
--- ns-3.45/src/wifi/model/wifi-standard-constants.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/wifi/model/wifi-standard-constants.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "wifi-standard-constants.h"
+
+namespace ns3
+{
+
+const Time WIFI_TU = MicroSeconds(1024);
+
+const Time EMLSR_RX_PHY_START_DELAY = MicroSeconds(20);
+
+const Time OFDM_SIFS_TIME_20MHZ = MicroSeconds(16);
+
+const Time OFDM_SLOT_TIME_20MHZ = MicroSeconds(9);
+
+const Time OFDM_SIFS_TIME_10MHZ = MicroSeconds(32);
+
+const Time OFDM_SLOT_TIME_10MHZ = MicroSeconds(13);
+
+const Time OFDM_SIFS_TIME_5MHZ = MicroSeconds(64);
+
+const Time OFDM_SLOT_TIME_5MHZ = MicroSeconds(21);
+
+const Time DSSS_SIFS_TIME = MicroSeconds(10);
+
+const Time DSSS_SLOT_TIME = MicroSeconds(20);
+
+const Time MAX_PROPAGATION_DELAY = MicroSeconds(1);
+
+const Time MEDIUM_SYNC_THRESHOLD = MicroSeconds(72);
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-standard-constants.h ns-3.46/src/wifi/model/wifi-standard-constants.h
--- ns-3.45/src/wifi/model/wifi-standard-constants.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/wifi/model/wifi-standard-constants.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,131 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef WIFI_STANDARD_CONSTANTS_H
+#define WIFI_STANDARD_CONSTANTS_H
+
+#include "ns3/nstime.h"
+#include "ns3/wifi-export.h"
+
+/**
+ * @file
+ * @ingroup wifi
+ * Declaration of the constants used across wifi module
+ */
+
+namespace ns3
+{
+
+/// Wi-Fi Time Unit value in microseconds (see IEEE 802.11-2020 sec. 3.1)
+/// Used to initialize WIFI_TU
+WIFI_EXPORT extern const Time WIFI_TU;
+
+/// aRxPHYStartDelay value to use when waiting for a new frame in the context of EMLSR operations
+/// (Sec. 35.3.17 of 802.11be D3.1)
+extern const Time EMLSR_RX_PHY_START_DELAY;
+
+/// aSIFSTime value for OFDM (20 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SIFS_TIME_20MHZ;
+
+/// aSlotTime duration for OFDM (20 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SLOT_TIME_20MHZ;
+
+/// aSIFSTime value for OFDM (10 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SIFS_TIME_10MHZ;
+
+/// aSlotTime duration for OFDM (10 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SLOT_TIME_10MHZ;
+
+/// aSIFSTime value for OFDM (5 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SIFS_TIME_5MHZ;
+
+/// aSlotTime duration for OFDM (5 MHz channel spacing)
+/// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
+extern const Time OFDM_SLOT_TIME_5MHZ;
+
+/// aSIFSTime duration for DSSS (Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2020)
+extern const Time DSSS_SIFS_TIME;
+
+/// aSlotTime duration for DSSS (Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2020)
+extern const Time DSSS_SLOT_TIME;
+
+/// maximum propagation delay
+WIFI_EXPORT extern const Time MAX_PROPAGATION_DELAY;
+
+/// The aMediumSyncThreshold defined by Sec. 35.3.16.18.1 of 802.11be D4.0
+WIFI_EXPORT extern const Time MEDIUM_SYNC_THRESHOLD;
+
+/// Subcarrier frequency spacing in Hz (Table 19-6 "Timing-related constants" of 802.11-2020)
+static constexpr uint32_t SUBCARRIER_FREQUENCY_SPACING{312500};
+
+/// Subcarrier frequency spacing for the HE modulated fields in Hz (Table 27-12 "Timing-related
+/// constants" of 802.11ax-2021)
+static constexpr uint32_t SUBCARRIER_FREQUENCY_SPACING_HE{78125};
+
+/// Size of the space of sequence numbers
+static constexpr uint16_t SEQNO_SPACE_SIZE{4096};
+
+/// Size of the half the space of sequence numbers (used to determine old packets)
+static constexpr uint16_t SEQNO_SPACE_HALF_SIZE{SEQNO_SPACE_SIZE / 2};
+
+/// This value conforms to the 802.11 specification
+static constexpr uint16_t MAX_MSDU_SIZE{2304};
+
+/// The length in octets of the IEEE 802.11 MAC FCS field
+static constexpr uint16_t WIFI_MAC_FCS_LENGTH{4};
+
+/// The minimum value for dot11RTSThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MIN_RTS_THRESHOLD{0};
+
+/// The maximum value for dot11RTSThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MAX_RTS_THRESHOLD{4692480};
+
+/// The default value for dot11RTSThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_DEFAULT_RTS_THRESHOLD{WIFI_MAX_RTS_THRESHOLD};
+
+/// The minimum value for dot11FragmentationThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MIN_FRAG_THRESHOLD{256};
+
+/// The maximum value for dot11FragmentationThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_MAX_FRAG_THRESHOLD{65535};
+
+/// The default value for dot11FragmentationThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
+static constexpr uint32_t WIFI_DEFAULT_FRAG_THRESHOLD{WIFI_MAX_FRAG_THRESHOLD};
+
+/// STA_ID to identify a single user (SU)
+static constexpr uint16_t SU_STA_ID{65535};
+
+/// Empty 242-tone RU identifier for HE (Section 26.11.7 802.11ax-2021)
+static constexpr uint8_t EMPTY_242_TONE_HE_RU{113};
+
+/// The minimum value for the association ID (Sec. 9.4.1.8 of 802.11-2020)
+static constexpr uint16_t MIN_AID{1};
+
+/// The maximum value for the association ID (Sec. 9.4.1.8 of 802.11-2020)
+static constexpr uint16_t MAX_AID{2007};
+
+/// STA_ID for a RU that is intended for no user (Section 26.11.1 802.11ax-2021)
+static constexpr uint16_t NO_USER_STA_ID{2046};
+
+/// Unassigned 242-tone RU identifier for EHT (Table Table 36-34 IEEE 802.11be D7.0)
+static constexpr uint8_t UNASSIGNED_242_TONE_EHT_RU{27};
+
+/// The maximum value for the association ID updated since 802.11be (Sec. 9.4.1.8 of 802.11be D7.0)
+static constexpr uint16_t EHT_MAX_AID{2006};
+
+/// AID value for Special User Info field in trigger frames (Sec. 9.3.1.22.3 of 802.11be D7.0)
+static constexpr uint16_t AID_SPECIAL_USER{2007};
+
+} // namespace ns3
+
+#endif /* WIFI_STANDARD_CONSTANTS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-standards.h ns-3.46/src/wifi/model/wifi-standards.h
--- ns-3.45/src/wifi/model/wifi-standards.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-standards.h	2025-10-01 18:46:32.000000000 -0700
@@ -10,10 +10,10 @@
 #define WIFI_STANDARD_H
 
 #include "wifi-phy-band.h"
-#include "wifi-types.h"
 #include "wifi-units.h"
 
 #include "ns3/abort.h"
+#include "ns3/wifi-export.h"
 
 #include <list>
 #include <map>
@@ -78,7 +78,18 @@
 /**
  * @brief map a given standard configured by the user to the allowed PHY bands
  */
-extern const std::map<WifiStandard, std::list<WifiPhyBand>> wifiStandards;
+WIFI_EXPORT extern const std::map<WifiStandard, std::list<WifiPhyBand>> wifiStandards;
+
+/**
+ * @ingroup wifi
+ * @brief Enumeration of frequency channel types
+ */
+enum class FrequencyChannelType : uint8_t
+{
+    DSSS = 0,
+    OFDM,
+    CH_80211P
+};
 
 /**
  * Get the type of the frequency channel for the given standard
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-types.cc ns-3.46/src/wifi/model/wifi-types.cc
--- ns-3.45/src/wifi/model/wifi-types.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/wifi/model/wifi-types.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,36 @@
+/*
+ * Copyright (c) 2025 Universita' degli Studi di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "wifi-types.h"
+
+#include "wifi-phy.h"
+
+namespace ns3
+{
+
+WifiChannelConfig::WifiChannelConfig(const std::list<TupleWithoutUnits>& tuples)
+{
+    std::for_each(tuples.cbegin(), tuples.cend(), [this](auto&& t) {
+        segments.emplace_back(std::make_from_tuple<SegmentWithoutUnits>(t));
+    });
+}
+
+WifiChannelConfig
+WifiChannelConfig::FromString(const std::string& settings, WifiStandard standard)
+{
+    WifiPhy::ChannelSettingsValue value;
+    value.DeserializeFromString(settings, WifiPhy::GetChannelSegmentsChecker());
+    auto channelCfg = WifiChannelConfig(value.Get());
+    if (standard != WIFI_STANDARD_UNSPECIFIED)
+    {
+        WifiPhy::SetUnspecifiedChannelParams(channelCfg, standard);
+    }
+    return channelCfg;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-types.h ns-3.46/src/wifi/model/wifi-types.h
--- ns-3.45/src/wifi/model/wifi-types.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-types.h	2025-10-01 18:46:32.000000000 -0700
@@ -9,13 +9,18 @@
 #ifndef WIFI_TYPES_H
 #define WIFI_TYPES_H
 
+#include "wifi-phy-band.h"
+#include "wifi-standards.h"
 #include "wifi-units.h"
 
 #include "ns3/fatal-error.h"
 
 #include <compare>
+#include <list>
 #include <map>
 #include <ostream>
+#include <tuple>
+#include <vector>
 
 namespace ns3
 {
@@ -82,14 +87,150 @@
 };
 
 /**
- * @ingroup wifi
- * @brief Enumeration of frequency channel types
+ * Struct defining the configuration of a wifi channel, which can be made of one or multiple
+ * channel segments.
  */
-enum class FrequencyChannelType : uint8_t
+struct WifiChannelConfig
 {
-    DSSS = 0,
-    OFDM,
-    CH_80211P
+    /// a channel segment, as a struct without units for channel width (to be deprecated when using
+    /// strong types)
+    struct SegmentWithoutUnits
+    {
+        uint8_t number{};                            ///< channel number
+        double width{};                              ///< channel width in MHz
+        WifiPhyBand band{WIFI_PHY_BAND_UNSPECIFIED}; ///< PHY band
+        uint8_t p20Index{};                          ///< primary20 index
+
+        /**
+         * Constructor.
+         *
+         * @param n the channel number
+         * @param w the channel width
+         * @param b the PHY band
+         * @param i the primary20 index
+         */
+        SegmentWithoutUnits(uint8_t n, double w, WifiPhyBand b, uint8_t i)
+            : number(n),
+              width(w),
+              band(b),
+              p20Index(i)
+        {
+        }
+    };
+
+    /// a channel segment, as a struct with units for channel width
+    struct Segment
+    {
+        uint8_t number{};                            ///< channel number
+        MHz_u width{};                               ///< channel width
+        WifiPhyBand band{WIFI_PHY_BAND_UNSPECIFIED}; ///< PHY band
+        uint8_t p20Index{};                          ///< primary20 index
+
+        /**
+         * Constructor.
+         *
+         * @param n the channel number
+         * @param w the channel width
+         * @param b the PHY band
+         * @param i the primary20 index
+         */
+        Segment(uint8_t n, MHz_u w, WifiPhyBand b, uint8_t i)
+            : number(n),
+              width(w),
+              band(b),
+              p20Index(i)
+        {
+        }
+
+        /**
+         * Converting constructor (to be deprecated when using strong types)
+         *
+         * @param s a channel segment as a struct without units for channel width
+         */
+        Segment(const SegmentWithoutUnits& s)
+            : number(s.number),
+              width(MHz_u{s.width}),
+              band(s.band),
+              p20Index(s.p20Index)
+        {
+        }
+
+        /**
+         * Three-way comparison operator
+         *
+         * @param rhs right hand side
+         * @return deduced comparison type
+         */
+        auto operator<=>(const Segment& rhs) const = default;
+    };
+
+    std::vector<Segment> segments; ///< channel config
+
+    WifiChannelConfig() = default;
+
+    /**
+     * Construct a channel config from a channel segment
+     *
+     * @param segment the channel segment
+     */
+    WifiChannelConfig(const Segment& segment)
+        : segments(std::vector<Segment>{segment})
+    {
+    }
+
+    /**
+     * Construct a channel config from a segment without units for channel width
+     *
+     * @param s the segment without units for channel width
+     */
+    WifiChannelConfig(const SegmentWithoutUnits& s)
+        : WifiChannelConfig(Segment(s))
+    {
+    }
+
+    /// a channel segment, as a tuple without units for channel width (to be deprecated when using
+    /// strong types)
+    using TupleWithoutUnits = std::tuple<uint64_t /* channel number */,
+                                         uint64_t /* channel width in MHz */,
+                                         WifiPhyBand /* PHY band */,
+                                         uint64_t /* primary20 index*/>;
+
+    /**
+     * Construct a channel config from a list of tuples without units for channel width
+     *
+     * @param tuples the list of tuples without units for channel width
+     */
+    WifiChannelConfig(const std::list<TupleWithoutUnits>& tuples);
+
+    /**
+     * Get the wifi channel config from a WifiPhy::ChannelSettings string
+     *
+     * @param settings the WifiPhy::ChannelSettings string
+     * @param standard the Wi-Fi standard
+     * @return the wifi channel config object
+     */
+    static WifiChannelConfig FromString(const std::string& settings,
+                                        WifiStandard standard = WIFI_STANDARD_UNSPECIFIED);
+
+    /// @return a const reference to the first channel segment
+    const Segment& front() const
+    {
+        return segments.front();
+    }
+
+    /// @return a reference to the first channel segment
+    Segment& front()
+    {
+        return segments.front();
+    }
+
+    /**
+     * Three-way comparison operator
+     *
+     * @param rhs right hand side
+     * @return deduced comparison type
+     */
+    auto operator<=>(const WifiChannelConfig& rhs) const = default;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/wifi-utils.cc ns-3.46/src/wifi/model/wifi-utils.cc
--- ns-3.45/src/wifi/model/wifi-utils.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/wifi-utils.cc	2025-10-01 18:46:32.000000000 -0700
@@ -253,4 +253,21 @@
     return apMac->GetGcrManager()->GetIndividuallyAddressedRecipient(addr1);
 }
 
+FrequencyRange
+GetFrequencyRange(WifiPhyBand band)
+{
+    switch (band)
+    {
+    case WIFI_PHY_BAND_2_4GHZ:
+        return WIFI_SPECTRUM_2_4_GHZ;
+    case WIFI_PHY_BAND_5GHZ:
+        return WIFI_SPECTRUM_5_GHZ;
+    case WIFI_PHY_BAND_6GHZ:
+        return WIFI_SPECTRUM_6_GHZ;
+    default:
+        NS_FATAL_ERROR("Undefined frequency range for " << band);
+        return {};
+    }
+}
+
 } // namespace ns3
